#include <stdio.h>
#include <sys/dcmd_chr.h>
#include "../include/ctidaglib.h"
	
int main()
{
	CtiUfpgaBoard brdInfo;
	int ret;
	float value;	
	unsigned short testreg, value_sh;
	

	ret = ConnectDAGBoard(&brdInfo, 0);
	if(ret != CTI_STATUS_OK)
	{
		printf("could not connect to DAG board error %x\n",ret);
	}
	
	ret = SetAdcCmd(brdInfo, ADC0, 1, CHANNEL0, 0, ADC_VP10);
	if(ret != CTI_STATUS_OK)
	{
		printf("SetAdcCmd error %x\n",ret);
	}
	ret = SetConfigDac(brdInfo, DAC0, DAC_VP10);
	if(ret != CTI_STATUS_OK)
	{
		printf("SetConfigDac error %x\n",ret);
	}
	sleep(1);
	ret = WriteDAC(brdInfo, DAC0, 4.5);
	if(ret != CTI_STATUS_OK)
	{
		printf("WriteDAC error %x\n",ret);
	}
	printf("written DAC0 4.5V\n");
	sleep(1);
	ret = ReadAdc(brdInfo, ADC0, &value);
	if(ret != CTI_STATUS_OK)
	{
		printf("ReadAdc error %x\n",ret);
	}
	printf("read ADC0 %fV\n",value);
	sleep(1);

	ret = SetAdcCmd(brdInfo, ADC1, 1, CHANNEL0, 0, ADC_VP10);
	if(ret != CTI_STATUS_OK)
	{
		printf("SetAdcCmd error %x\n",ret);
	}
	ret = SetConfigDac(brdInfo, DAC1, DAC_VP10);
	if(ret != CTI_STATUS_OK)
	{
		printf("SetConfigDac error %x\n",ret);
	}
	sleep(1);
	ret = WriteDAC(brdInfo, DAC1, 7.5);
	if(ret != CTI_STATUS_OK)
	{
		printf("WriteDAC error %x\n",ret);
	}
	printf("written DAC1 7.5V\n");
	sleep(1);
	ret = ReadAdc(brdInfo, ADC1, &value);
	if(ret != CTI_STATUS_OK)
	{
		printf("ReadAdc error %x\n",ret);
	}
	printf("read ADC1 %fV\n",value);

	sleep(1);
	ret = SetAdcCmd(brdInfo, ADC2, 1, CHANNEL0, 0, ADC_VP10);
	if(ret != CTI_STATUS_OK)
	{
		printf("SetAdcCmd error %x\n",ret);
	}
	ret = SetConfigDac(brdInfo, DAC2, DAC_VP10);
	if(ret != CTI_STATUS_OK)
	{
		printf("SetConfigDac error %x\n",ret);
	}
	sleep(1);
	ret = WriteDAC(brdInfo, DAC2, 3.1);
	if(ret != CTI_STATUS_OK)
	{
		printf("WriteDAC error %x\n",ret);
	}
	printf("written DAC2 3.1V\n");
	sleep(1);
	ret = ReadAdc(brdInfo, ADC2, &value);
	if(ret != CTI_STATUS_OK)
	{
		printf("ReadAdc error %x\n",ret);
	}
	printf("read ADC2 %fV\n",value);

	sleep(1);
	ret = SetAdcCmd(brdInfo, ADC3, 1, CHANNEL0, 0, ADC_VP10);
	if(ret != CTI_STATUS_OK)
	{
		printf("SetAdcCmd error %x\n",ret);
	}
	ret = SetConfigDac(brdInfo, DAC3, DAC_VP10);
	if(ret != CTI_STATUS_OK)
	{
		printf("SetConfigDac error %x\n",ret);
	}
	sleep(1);
	ret = WriteDAC(brdInfo, DAC3, 5.5);
	if(ret != CTI_STATUS_OK)
	{
		printf("WriteDAC error %x\n",ret);
	}
	printf("written DAC3 5.5V\n");
	sleep(1);
	ret = ReadAdc(brdInfo, ADC3, &value);
	if(ret != CTI_STATUS_OK)
	{
		printf("ReadAdc error %x\n",ret);
	}
	printf("read ADC3 %fV\n",value);
	sleep(1);

	printf("set GPIO 0xff00\n");
	ret = SetGPIO(brdInfo, 0xff00);
	if(ret != CTI_STATUS_OK)
	{
		printf("SetGPIO error %x\n",ret);
	}
	value_sh = 0xffff;
	printf("output GPIO 0x%x\n",value_sh);
	ret = OutputGPIO(brdInfo, value_sh);
	if(ret != CTI_STATUS_OK)
	{
		printf("OutputGPIO error %x\n",ret);
	}

	ret = InputGPIO(brdInfo, &testreg);
	if(ret != CTI_STATUS_OK)
	{
		printf("InputGPIO error %x\n",ret);
	}
	printf("input GPIO %x\n",testreg);

	ret = DisconnectDAGBoard(&brdInfo);
  if(ret != CTI_STATUS_OK)
  {
      printf("could not disconnect DAG board error %x\n",ret);
  }
	
}
